package com.loafle.overflow.model.infra;

import com.loafle.overflow.model.meta.MetaInfraVendor;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity(name = "INFRA_SERVICE")
@Table(name = "INFRA_SERVICE", schema = "public")
@DiscriminatorValue("7")
public class InfraService extends Infra {
  // private Long id;
  private InfraHost infraHost;
  private String portType;
  private Integer port;
  private MetaInfraVendor metaInfraVendor;
  private Date createDate;
  private Boolean tlsType;

  // @Id
  // @GeneratedValue(strategy= GenerationType.IDENTITY)
  // public Long getId() {
  // return id;
  // }
  //
  // public void setId(Long id) {
  // this.id = id;
  // }

  @ManyToOne
  @JoinColumn(name = "INFRA_HOST_ID", nullable = true)
  public InfraHost getInfraHost() {
    return infraHost;
  }

  public void setInfraHost(InfraHost infraHost) {
    this.infraHost = infraHost;
  }

  @Basic
  @Column(name = "PORT_TYPE", nullable = true)
  public String getPortType() {
    return portType;
  }

  public void setPortType(String portType) {
    this.portType = portType;
  }

  @Basic
  @Column(name = "PORT", nullable = true)
  public Integer getPort() {
    return port;
  }

  public void setPort(Integer port) {
    this.port = port;
  }

  @ManyToOne
  @JoinColumn(name = "META_INFRA_VENDOR_ID", nullable = true)
  public MetaInfraVendor getMetaInfraVendor() {
    return metaInfraVendor;
  }

  public void setMetaInfraVendor(MetaInfraVendor metaInfraVendor) {
    this.metaInfraVendor = metaInfraVendor;
  }

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = true, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  @Basic
  @Column(name = "TLS_TYPE", nullable = true)
  public Boolean isTlsType() {
    return tlsType;
  }

  public void setTlsType(Boolean tlsType) {
    this.tlsType = tlsType;
  }
}
