package com.loafle.overflow.model.meta;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "META_PROBE_PACKAGE", schema = "public")
public class MetaProbePackage {
  private Long id;
  private MetaProbeVersion metaProbeVersion;
  private MetaProbeOs metaProbeOs;
  private MetaProbeArchitecture metaProbeArchitecture;
  private Date createDate;

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  @ManyToOne
  @JoinColumn(name = "META_PROBE_VERSION_ID", nullable = false)
  public MetaProbeVersion getMetaProbeVersion() {
    return metaProbeVersion;
  }

  public void setMetaProbeVersion(MetaProbeVersion metaProbeVersion) {
    this.metaProbeVersion = metaProbeVersion;
  }

  @ManyToOne
  @JoinColumn(name = "META_PROBE_OS_ID", nullable = false)
  public MetaProbeOs getMetaProbeOs() {
    return metaProbeOs;
  }

  public void setMetaProbeOs(MetaProbeOs metaProbeOs) {
    this.metaProbeOs = metaProbeOs;
  }

  @ManyToOne
  @JoinColumn(name = "META_PROBE_ARCHITECTURE_ID", nullable = false)
  public MetaProbeArchitecture getMetaProbeArchitecture() {
    return metaProbeArchitecture;
  }

  public void setMetaProbeArchitecture(MetaProbeArchitecture metaProbeArchitecture) {
    this.metaProbeArchitecture = metaProbeArchitecture;
  }

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

}
