package com.loafle.overflow.service.central.probe;

import com.loafle.overflow.core.annotation.ProbeAPI;
import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.probe.Probe;

import java.util.List;

/**
 * Created by snoop on 17. 6. 28.
 */
public interface ProbeService {
  // NoauthProbe.acceptNoAuthProbe
  Probe regist(Probe probe) throws OverflowException;

  // NoauthProbe.acceptNoAuthProbe
  List<Probe> regist(List<Probe> probes) throws OverflowException;

  @WebappAPI
  List<Probe> readAllByDomainID(Long id) throws OverflowException;

  @WebappAPI
  Probe read(Long id) throws OverflowException;

  @WebappAPI
  Probe modifyDisplayName(Long probeId, String displayName) throws OverflowException;

  @ProbeAPI // ?
  Probe readByProbeKey(String probeKey) throws OverflowException;

  @ProbeAPI // ?
  Probe modify(Probe probe) throws OverflowException;

  @ProbeAPI
  void onConnect(String probeKey, String connectAddress) throws OverflowException;

  @ProbeAPI
  void onDisconnect(String probeKey) throws OverflowException;

}
